# Welcome to cg-django-uaa\'s documentation

This is a [cloud.gov](https://cloud.gov/) UAA authentication backend for
Django. Features include:

- A handy [fake cloud.gov authentication server](./quickstart.md#using-the-fake-cloudgov-server)
    that makes it easy to log in as any user during development.
- Transparent refreshing of short-lived access tokens, ensuring that
    users are automatically logged out of the system soon after
    cloud.gov says they are unauthorized.

To get started, see the [Quick start guide](./quickstart.md).

## Table of contents

- [Quick start guide](./quickstart.md)
- [Authentication backends](./backends.md)
- [Decorators](./decorators.md)
- [Developing cg-django-uaa](./developing.md)
- [Change log](./changelog.md)
